##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################

from osv import osv, fields

class hr_payroll_cr_contract_data(Prototype)(osv.osv):
	_name = 'hr.payroll.cr.contract.data(Prototype)'
	_columns = {
	}
hr_payroll_cr_contract_data(Prototype)()

class hr_payroll_cr_incapacity_period(osv.osv):
	_name = 'hr.payroll.cr.incapacity.period'
	_columns = {
		'start_date': fields.date('Start Date'),
		'end_date': fields.date('End Date'),
		'notes': fields.text('Notes'),
		'detail': fields.char('Detail', size=150),
		'incapacity_period_per_day': fields.many2one('hr.payroll.cr.incapacity.period.per.day', 'Incapacity Period Per Day'),
	}
hr_payroll_cr_incapacity_period()

class hr_payroll_cr_incapacity_period_per_day(osv.osv):
	_name = 'hr.payroll.cr.incapacity.period.per.day'
	_columns = {
		'percent': fields.boolean('Percent', Required=True),
		'amount': fields.float('Amount', digits=(16 , int(config['price_accuracy']))),
		'payment': fields.many2one('hr.payroll.cr.payment', 'Payment'),
	}
hr_payroll_cr_incapacity_period_per_day()

class hr_payroll_cr_over_salary(osv.osv):
	_name = 'hr.payroll.cr.over.salary'
	_columns = {
		'start_date': fields.date('Start Date'),
		'end_date': fields.date('End Date'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'notes': fields.text('Notes'),
		'detail': fields.char('Detail', size=150),
		'percent': fields.boolean('Percent'),
		'account': fields.many2one('account.account', 'Account'),
	}
hr_payroll_cr_over_salary()

class hr_payroll_cr_permit(osv.osv):
	_name = 'hr.payroll.cr.permit'
	_columns = {
		'with_salary': fields.boolean('With Salary', help='si es con salario o no'),
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
		'start_date': fields.date('Start Date'),
		'end_date': fields.date('End Date'),
		'permit_per_day': fields.one2many('hr.payroll.cr.permit.per.day', 'Permit Per Day'),
	}
hr_payroll_cr_permit()

class hr_payroll_cr_permit_per_day(osv.osv):
	_name = 'hr.payroll.cr.permit.per.day'
	_columns = {
		'date': fields.date('Date'),
		'payment': fields.many2one('hr.payroll.cr.payment', 'Payment'),
	}
hr_payroll_cr_permit_per_day()

class hr_payroll_cr_extra_hour(osv.osv):
	_name = 'hr.payroll.cr.extra.hour'
	_columns = {
		'paid': fields.boolean('Paid'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'date': fields.date('Date'),
		'hours': fields.float('Hours', digits=(16, int(config[price_accuracy]))),
		'account': fields.many2one('account.account', 'Account'),
	}
hr_payroll_cr_extra_hour()

class hr_payroll_cr_absence(osv.osv):
	_name = 'hr.payroll.cr.absence'
	_columns = {
		'date': fields.date('Date'),
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
	}
hr_payroll_cr_absence()

class hr_payroll_cr_payment_per_contract(osv.osv):
	"""pago ya sea cada quincena, mes o semana. Es todos los pagos que se hagan a un contrato."""
	_name = 'hr.payroll.cr.payment.per.contract'
	_columns = {
		'date': fields.date('Date'),
		'payment_per_contract_line': fields.one2many('hr.payroll.cr.payment.per.contract.line', 'Payment Line'),
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
		'contract': fields.one2many('hr.payroll.cr.contract', 'Contract'),
		'total_paid': fields.float('Total Paid', digits=(16, int(config[price_accuracy]))),
		'total_retained': fields.float('Total Retained', digits=(16, int(config[price_accuracy]))),
	}
hr_payroll_cr_payment_per_contract()

class hr_payroll_cr_contract(Inherits)(osv.osv):
	"""Remive working hours per day"""
	_name = 'hr.payroll.cr.contract(Inherits)'
	_columns = {
		'payment_per_contract': fields.one2many('hr.payroll.cr.payment.per.contract),
	}
hr_payroll_cr_contract(Inherits)()

class hr_payroll_cr_working_holiday(osv.osv):
	_name = 'hr.payroll.cr.working.holiday'
	_columns = {
		'date': fields.date('Date'),
		'hours': fields.float('Hours', digits=(16, int(config[price_accuracy]))),
		'holiday': fields.many2one('hr.payroll.cr.holiday', 'Holiday'),
		'account': fields.many2one('account.account', 'Account'),
	}
hr_payroll_cr_working_holiday()

class hr_payroll_cr_employee(Inherits)(osv.osv):
	_name = 'hr.payroll.cr.employee(Inherits)'
	_columns = {
	}
hr_payroll_cr_employee(Inherits)()

class hr_payroll_cr_deduction(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.deduction'
	_columns = {
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
		'account': fields.many2one('account.account', 'Account'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'name': fields.char('Name', size=150),
		'percent': fields.boolean('Percent'),
		'type': fields.char('Type', size=1),
		'code': fields.text('Code'),
	}
hr_payroll_cr_deduction()

class hr_payroll_cr_other_deduction(osv.osv):
	_name = 'hr.payroll.cr.other.deduction'
	_columns = {
		'date': fields.date('Date'),
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'type': fields.char('Type', size=64),
		'account': fields.many2one('account.account', 'Account'),
	}
hr_payroll_cr_other_deduction()

class hr_payroll_cr_loan(osv.osv):
	_name = 'hr.payroll.cr.loan'
	_columns = {
		'start_date': fields.date('Start Date'),
		'end_date': fields.date('End Date'),
		'payment': fields.float('Payment', digits(16, int(config[price_accuracy]))),
		'detail': fields.char('Detail', size=150 ),
		'notes': fields.text('Notes'),
		'paid': fields.boolean('Paid'),
		'principal': fields.float('Principal', digits=(16, int(config[price_accuracy]))),
		'interest': fields.float('Interests', digits=(16, int(config[price_accuracy]))),
		'loan_type': fields.many2one('hr.payroll.cr.loan.type', 'Loan Type'),
	}
hr_payroll_cr_loan()

class hr_payroll_cr_other_income(osv.osv):
	_name = 'hr.payroll.cr.other.income'
	_columns = {
		'date': fields.date('Date'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy])),
		'note': fields.text('Note'),
		'detail': fields.char('Detail', size=150),
		'payment': fields.many2one('hr.payroll.cr.payment', 'Payment'),
		'account': fields.many2one('account.account', 'Account'),
	}
hr_payroll_cr_other_income()

class hr_payroll_cr_saving(osv.osv):
	_name = 'hr.payroll.cr.saving'
	_columns = {
		'start_date': fields.date('Start Date'),
		'end_date': fields.date('End Date'),
		'quota': fields.float('Quota', digits=(16, int(config[price_accuracy]))),
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
		'total': fields.float('Total', digits=(16, int(config[price_accuracy]))),
		'type': fields.many2one('hr.payroll.cr.saving.type', 'Saving Type'),
		'percent': fields.boolean('Percent'),
		'contract': fields.many2one('hr.payroll.cr.contract', 'Contract'),
	}
hr_payroll_cr_saving()

class hr_payroll_cr_christmas_bonus(osv.osv):
	_name = 'hr.payroll.cr.christmas.bonus'
	_columns = {
		'date': fields.date('Date'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'quota': fields.one2many('hr.payroll.cr.christmas.bonus.quota', 'Christmas Bonus Quota'),
		'payment': fields.one2many('hr.payroll.cr.christmas.bonus.payment', 'Christmas Bonus Payment'),
	}
hr_payroll_cr_christmas_bonus()

class hr_payroll_cr_saving_quota(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.saving.quota'
	_columns = {
		'date': fields.date('Date'),
		'quota': fields.float('Quota', digits=(16, int(config[price_accuracy]))),
		'saving': fields.many2one('hr.payroll.cr.saving', 'Saving'),
		'total': fields.float('Total', digits=(16, int(config[price_accuracy]))),
		'payment_per_contract': fields.many2one('hr.payroll.cr.payment.per.contract', 'Payment Per Contract'),
	}
hr_payroll_cr_saving_quota()

class hr_payroll_cr_loan_payment(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.loan.payment'
	_columns = {
		'date': fields.date('Date'),
		'payment': fields.float('Payment', digits=(16, int(config[price_accuracy]))),
		'loan': fields.many2one('hr.payroll.cr.loan', 'Loan'),
		'total': fields.float('Total', digits=(16, int(config[price_accuracy]))),
		'payment_per_contract': fields.many2one('hr.payroll.cr.payment.per.contract', 'Payment Per Contract'),
	}
hr_payroll_cr_loan_payment()

class hr_payroll_cr_christmas_bonus_quota(osv.osv):
	_name = 'hr.payroll.cr.christmas.bonus.quota'
	_columns = {
		'date': fields.date('Date'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'detail': fields.char('Detail', size=150),
	}
hr_payroll_cr_christmas_bonus_quota()

class hr_payroll_cr_unemployement_fee(osv.osv):
	_name = 'hr.payroll.cr.unemployement.fee'
	_columns = {
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
	}
hr_payroll_cr_unemployement_fee()

class hr_payroll_cr_payment_per_contract_line(osv.osv):
	_name = 'hr.payroll.cr.payment.per.contract.line'
	_columns = {
		'detail': fields.char('Detail', size=150),
		'type': fields.char('Type', size=64),
		'code': fields.integer('Code', help='codigo para los tipos de pago, ya sea aguinaldo, pago quincenal, semanal, etc.'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy])))),
	}
hr_payroll_cr_payment_per_contract_line()

class hr_payroll_cr_payroll(osv.osv):
	_name = 'hr.payroll.cr.payroll'
	_columns = {
		'date': fields.date('Date'),
		'payment': fields.one2many('hr.payroll.cr.payment', 'Payment'),
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
	}
hr_payroll_cr_payroll()

class hr_payroll_cr_working_hours(osv.osv):
	_name = 'hr.payroll.cr.working.hours'
	_columns = {
		'sunday': fields.boolean('Sunday'),
		'monday': fields.boolean('Monday'),
		'tuesday': fields.boolean('Tuesday'),
		'wednesday': fields.boolean('Wednesday'),
		'thursday': fields.boolean('Thursday'),
		'friday': fields.boolean('Friday'),
		'saturday': fields.boolean('Saturday'),
		'hoursperday': fields.integer('Hours Per Day'),
		'detail': fields.char('Detail', size=150),
		'note': fields.text('Note'),
	}
hr_payroll_cr_working_hours()

class hr_payroll_cr_company(inherits)(osv.osv):
	_name = 'hr.payroll.cr.company(inherits)'
	_columns = {
		'min_days_for_vacation': fields.integer('Minimum days for vacation'),
		'default_over_salary_account': fields.many2one('account.account', 'Default Account'),
		'default_extra_hours_account': fields.many2one('account.account', 'Default Account'),
		'default_saving_account': fields.many2one('account.account', 'Default Account'),
		'default_loan_account': fields.many2one('account.account', 'Default Account'),
		'default_working_holiday_account': fields.many2one('account.account', 'Default Account'),
		'default_other_income_account': fields.many2one('account.account', 'Default Account'),
		'default_incapacity_period_type_account': fields.many2one('account.account', 'Account'),
		'default_other_deduction_account': fields.many2one('account.account', 'Default Account'),
		'christmas_bonus_account': fields.many2one('account.account', 'Account'),
		'unemployment_fee_account': fields.many2one('account.account', 'Account'),
		'default_commission_account': fields.many2one('account.account', 'Account'),
	}
hr_payroll_cr_company(inherits)()

class hr_payroll_cr_incapacity_period_type_line(osv.osv):
	_name = 'hr.payroll.cr.incapacity.period.type.line'
	_columns = {
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'start_date': fields.date('Start Date'),
		'end_date': fields.date('End Date'),
		'percent': fields.boolean('Percent'),
	}
hr_payroll_cr_incapacity_period_type_line()

class hr_payroll_cr_incapacity_period_type(osv.osv):
	_name = 'hr.payroll.cr.incapacity.period.type'
	_columns = {
		'notes': fields.text('Notes'),
		'periodtypeline': fields.one2many('hr.payroll.cr.periodtype.line', 'Period Type Line'),
		'name': fields.char('Name', size=50),
		'detail': fields.char('Detail', size=150),
	}
hr_payroll_cr_incapacity_period_type()

class hr_payroll_cr_saving_type(osv.osv):
	_name = 'hr.payroll.cr.saving.type'
	_columns = {
		'name': fields.char('Name', size=64),
		'percent': fields.boolean('Percent'),
		'quota': fields.float('Quota', digits=(16, int(config[price_accuracy]))),
		'Name': fields.char('Name', size=150),
		'notes': fields.text('Notes'),
	}
hr_payroll_cr_saving_type()

class hr_payroll_cr_loan_type(osv.osv):
	_name = 'hr.payroll.cr.loan.type'
	_columns = {
		'name': fields.char('Name', size=150),
		'interest': fields.float('Interest', digits=(16, int(config[price_accuracy]))),
		'notes': fields.text('Notes'),
		'deadline': fields.date('Date Line'),
		'principal': fields.float('Principal', digits=(16, int(config[price_accuracy]))),
	}
hr_payroll_cr_loan_type()

class hr_payroll_cr_holiday(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.holiday'
	_columns = {
		'date': fields.date('Date'),
		'detail': fields.char('Detail', size=150),
	}
hr_payroll_cr_holiday()

class hr_payroll_cr_christmas_bonus_payment(osv.osv):
	_name = 'hr.payroll.cr.christmas.bonus.payment'
	_columns = {
		'date': fields.date('Date'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
		'payment': fields.many2one('hr.payroll.cr.payment', 'Payment'),
	}
hr_payroll_cr_christmas_bonus_payment()

class hr_payroll_cr_vacation(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.vacation'
	_columns = {
		'days': fields.integer('Days'),
		'contract': fields.many2one('hr.payroll.cr.contract', 'Contract'),
		'notes': fields.text('Notes'),
		'history': fields.one2many('hr.payroll.cr.vacation.history', 'Vacation History'),
	}
hr_payroll_cr_vacation()

class hr_payroll_cr_payment(osv.osv):
	_name = 'hr.payroll.cr.payment'
	_columns = {
		'date': fields.date('Date'),
		'detail': fields.char('Detail'),
		'notes': fields.text('Notes'),
		'total_paid': fields.float('Total Paid', digits=(16, int(config[price_accuracy]))),
		'total_retained': fields.float('Total Retained', digits=(16, int(config[price_accuracy]))),
		'payment_line': fields.one2many('hr.payroll.cr.payment.line', 'Payment Line'),
	}
hr_payroll_cr_payment()

class hr_payroll_cr_payment_line(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.payment.line'
	_columns = {
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
		'date': fields.date('Date'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'account': fields.many2one('account.account', 'Account'),
	}
hr_payroll_cr_payment_line()

class hr_payroll_cr_commission(osv.osv):
	_name = 'hr.payroll.cr.commission'
	_columns = {
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'notes': fields.text('Notes'),
		'detail': fields.char('Detail', size=150),
		'percent': fields.boolean('Percent'),
		'account': fields.many2one('account.account', 'Account'),
	}
hr_payroll_cr_commission()

class hr_payroll_cr_vacation_history(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.vacation.history'
	_columns = {
		'detail': fields.char('Detail', size=150),
		'date': fields.date('Date'),
		'notes': fields.text('Notes'),
		'total': fields.float('Total', digits=(16, int(config[price_accuracy]))),
	}
hr_payroll_cr_vacation_history()

class hr_payroll_cr_exonerated_retirement_fund(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.exonerated.retirement.fund'
	_columns = {
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'detail': fields.char('Detail', size=150),
		'date': fields.date('Date'),
		'percent': fields.float('Percent', digits=(16, int(config[price_accuracy]))),
	}
hr_payroll_cr_exonerated_retirement_fund()

class hr_payroll_cr_taxed_retirement_fund(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.taxed.retirement.fund'
	_columns = {
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'detail': fields.char('Detail', size=150),
		'date': fields.date('Date'),
		'percent': fields.float('Percent', digits=(16, int(config[price_accuracy]))),
	}
hr_payroll_cr_taxed_retirement_fund()

class hr_payroll_cr_retirement_fund(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.retirement.fund'
	_columns = {
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'fund_operator': fields.many2one('partner.partner', 'Fund Operator'),
		'contract': fields.many2one('hr.payroll.cr.contract', 'Contract'),
		'exonerated_retirement_fund': fields.one2many('hr.payroll.cr.exonerated.retirement.fund', 'Exonerated Retirement Fund'),
		'taxed_retirement_fund': fields.one2many('hr.payroll.cr.taxed.retirement.fund', 'Taxed Retirement Fund'),
		'retirement_fund_history': fields.one2many('hr.payroll.cr.retirement.fund.history', 'Retirement Fund History'),
	}
hr_payroll_cr_retirement_fund()

class hr_payroll_cr_retirement_fund_history(osv.osv):
	"""(NULL)"""
	_name = 'hr.payroll.cr.retirement.fund.history'
	_columns = {
		'detail': fields.char('Detail', size=150),
		'notes': fields.text('Notes'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
		'date': fields.date('Date'),
	}
hr_payroll_cr_retirement_fund_history()

class Empoyer_Social_Security(osv.osv):
	"""(NULL)"""
	_name = 'Empoyer.Social.Security'
	_columns = {
		'name': fields.char('Name', size=64),
		'account': fields.one2many('account.account', 'Account'),
		'percent': fields.float('Percent', digits=(16, int(config[price_accuracy]))),
		'notes': fields.text('Notes'),
		'amount': fields.float('Amount', digits=(16, int(config[price_accuracy]))),
	}
Empoyer_Social_Security()

